# -*- coding: utf-8 -*-

import numpy as np
from struct import *
import binascii

class Trace(object):
    def __init__(self):
        self.curve = []
        self.data = {}
    def __del__(self):
        pass

class BinaryReader(object):
    def __init__(self,filename):
        self.file_handler = open(filename,'r')
        if None != self.file_handler:
            self.read_header()
            self.read_curves()
    def __del__(self):
        self.file_handler.close()
    def read_curves(self):        
        self.traces = [Trace() for i in range(self.nb_curves)]
        for i in range(self.nb_curves):
            for field in self.fields:
                value = self.file_handler.read(field[1])
                self.traces[i].data[field[0]] = value
            trace_length = unpack('I',self.file_handler.read(4))[0]
            self.traces[i].curve = bytearray(self.file_handler.read(trace_length))
    def read_header(self):
        self.nb_curves = unpack('I',self.file_handler.read(4))[0]
        self.nb_fields = unpack('B',self.file_handler.read(1))[0]
        self.fields = []
        for i in range(self.nb_fields):
            key_size = unpack('B',self.file_handler.read(1))[0]
            key = self.file_handler.read(key_size)
            field_size = unpack('I',self.file_handler.read(4))[0]
            self.fields.append([key,field_size]);
    def get_nb_curves(self):
        return self.nb_curves
    def get_curve(self,index):
        return self.traces[index]
    
if "__main__" == __name__:
    reader = BinaryReader("/home/bgerard/IRISA/SIC/AES_SW.bin")
